//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers   8
#property indicator_color1    LimeGreen
#property indicator_color2    LimeGreen
#property indicator_color3    DarkGray
#property indicator_color4    Orange
#property indicator_color5    Orange
#property indicator_color6    LimeGreen
#property indicator_color7    Orange
#property indicator_color8    Orange
#property indicator_width6    2
#property indicator_width7    2
#property indicator_width8    2
#property indicator_style2    STYLE_DOT
#property indicator_style3    STYLE_DOT
#property indicator_style4    STYLE_DOT
//
//
//
//
//

extern int    T3Period          = 20;
extern int    T3Price           = PRICE_CLOSE;
extern double T3Hot             = 0.7;
extern bool   T3Original        = false;
extern int    Stochastic.Period = 50;
extern int    Bollinger.Period  = 30;
extern double Bollinger.Width   = 2;
extern double Level.Up          = 80;
extern double Level.Down        = 20;

//
//
//
//
//

double upup[];
double updn[];
double midd[];
double dnup[];
double dndn[];
double value[];
double valueda[];
double valuedb[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,upup);
   SetIndexBuffer(1,updn);
   SetIndexBuffer(2,midd);
   SetIndexBuffer(3,dnup);
   SetIndexBuffer(4,dndn);
   SetIndexBuffer(5,value);
   SetIndexBuffer(6,valueda);
   SetIndexBuffer(7,valuedb);
      IndicatorShortName("Stochastic of T3 "+T3Period+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double t3[];
double stoch[];
double slope[];
int start()
{
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArraySize(t3)!=Bars)    ArrayResize(t3,Bars);
           if (ArraySize(stoch)!=Bars) ArrayResize(stoch,Bars);
           if (ArraySize(slope)!=Bars) ArrayResize(slope,Bars);
   
   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      if (slope[Bars-limit-1]==-1) CleanPoint(limit,valueda,valuedb);
      t3[r] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i);
      
      //
      //
      //
      //
      //
      
      double sma = iMA(NULL,0,    Bollinger.Period,0,MODE_SMA,T3Price,i);
      double dev = iStdDev(NULL,0,Bollinger.Period,0,MODE_SMA,T3Price,i)*Bollinger.Width;
      double hi  = t3[r];
      double lo  = t3[r];
         for (int k=1; k<Stochastic.Period; k++)
         {
            hi = MathMax(hi,t3[r-k]);
            lo = MathMin(lo,t3[r-k]);
         }
      if (hi != lo)
            stoch[r] = (t3[r]-lo)/(hi-lo);
      else  stoch[r] = 0.00;
      upup[i]    = sma+dev;
      dndn[i]    = sma-dev;
      midd[i]    = sma;
      updn[i]    = dndn[i]+dev*2.0*Level.Up/100.0;
      dnup[i]    = dndn[i]+dev*2.0*Level.Down/100.0;
      value[i]   = dndn[i]+dev*2.0*stoch[r];
      valueda[i] = EMPTY_VALUE;
      valuedb[i] = EMPTY_VALUE;
      slope[r] = slope[r-1];
         if (stoch[r]>stoch[r-1]) slope[r] =  1;
         if (stoch[r]<stoch[r-1]) slope[r] = -1;
         if (slope[r]==-1) PlotPoint(i,valueda,valuedb,value);
   }         
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}